Imports System.Xml

Module Utility

    Public Sub XmlToListbox(ByVal xd As XmlDocument, _
     ByVal lb As ListBox)
        ' Get the document root
        Dim xnodRoot As XmlNode = xd.DocumentElement
        ' Walk the tree and display it
        Dim xnodWorking As XmlNode
        If xnodRoot.HasChildNodes Then
            xnodWorking = xnodRoot.FirstChild
            While Not IsNothing(xnodWorking)
                AddChildren(xnodWorking, lb, 0)
                xnodWorking = xnodWorking.NextSibling
            End While
        End If
    End Sub

    Private Sub AddChildren(ByVal xnod As XmlNode, _
     ByVal lb As ListBox, ByVal Depth As Integer)
        ' Add this node to the listbox
        Dim strNode As String
        Dim intI As Integer
        Dim intJ As Integer
        Dim atts As XmlAttributeCollection
        ' Only process Text and Element nodes
        If (xnod.NodeType = XmlNodeType.Element) Or _
         (xnod.NodeType = XmlNodeType.Text) Then
            strNode = ""
            For intI = 1 To Depth
                strNode &= " "
            Next
            strNode = strNode & xnod.Name & " "
            strNode &= xnod.NodeType.ToString
            strNode = strNode & ": " & xnod.Value
            lb.Items.Add(strNode)
            ' Now add the attributes, if any
            atts = xnod.Attributes
            If Not atts Is Nothing Then
                For intJ = 0 To atts.Count - 1
                    strNode = ""
                    For intI = 1 To Depth + 1
                        strNode &= " "
                    Next
                    strNode = strNode & _
                     atts(intJ).Name & " "
                    strNode &= atts(intJ).NodeType.ToString
                    strNode = strNode & ": " & _
                     atts(intJ).Value
                    lb.Items.Add(strNode)
                Next
            End If
            ' Recursively walk the children of this node
            Dim xnodworking As XmlNode
            If xnod.HasChildNodes Then
                xnodworking = xnod.FirstChild
                While Not IsNothing(xnodworking)
                    AddChildren(xnodworking, lb, Depth + 1)
                    xnodworking = xnodworking.NextSibling
                End While
            End If
        End If
    End Sub
End Module
