Imports System
Imports System.Data
Imports System.Data.SqlClient

' Marshal-by-Reference Remotable Object
Public Class DbConnect
    Inherits MarshalByRefObject
    Private sqlconn As SqlConnection

    ' Default constructor connects to the Northwind 
    ' database
    Public Sub New()
        sqlconn = New SqlConnection( _
         "data source=(local);" & _
         "initial catalog=Northwind;" & _
         "integrated security=SSPI")
        Console.WriteLine( _
         "Created a new connection " & _
         "to the Northwind database")
    End Sub

    ' Parameterized constructor connects to the 
    ' specified database
    Public Sub New(ByVal DbName As String)
        sqlconn = New SqlConnection( _
         "data source=(local);" & _
         "initial catalog=" & DbName & ";" & _
         "integrated security=SSPI")
        Console.WriteLine( _
         "Created a new connection " & _
         "to the " & DbName & " database")
    End Sub

    Public Function ExecuteQuery( _
     ByVal strQuery As String) As DataSet
        Console.Write("Starting to execute " & _
         "the query...")
        ' Create a SqlCommand to represent the query
        Dim sqlcmd As SqlCommand = _
         sqlconn.CreateCommand()
        sqlcmd.CommandType = CommandType.Text
        sqlcmd.CommandText = strQuery

        ' Create a SqlDataAdapter object
        ' to talk to the database
        Dim sqlda As SqlDataAdapter = _
         New SqlDataAdapter()
        sqlda.SelectCommand = sqlcmd
        ' Create a DataSet to hold the results
        Dim ds As DataSet = New DataSet()
        Try
            ' Fill the DataSet
            sqlda.Fill(ds, "Results")
        Catch ex As Exception
            Console.WriteLine(ex.Message, _
             "Error executing query")
        End Try
        Console.WriteLine("Done.")
        ExecuteQuery = ds
    End Function
End Class
