Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.EnterpriseServices
Imports System.Runtime.InteropServices

Public Interface INorthwind
    Function ExecuteQuery(ByVal strQuery As String) _
     As DataSet
    Function UpdateData(ByVal ds As DataSet) As Integer
End Interface

<ClassInterface(ClassInterfaceType.None)> _
Public Class NorthwindSC
    Inherits ServicedComponent
    Implements INorthwind

    Private sqlcnn As SqlConnection
    Private sqlda As SqlDataAdapter
    Private ds As DataSet

    Public Sub New()
        ' Create a connection to the 
        ' Northwind SQL Server database
        sqlcnn = New SqlConnection( _
         "data source=(local);" & _
         "initial catalog=Northwind;" & _
         "integrated security=SSPI")
    End Sub

    ' This method executes a SELECT query and
    ' returns the results in a DataSet object
    Public Function ExecuteQuery( _
     ByVal strQuery As String) As DataSet _
     Implements INorthwind.ExecuteQuery
        ' Create a SqlDataAdapter object to 
        ' talk to the database
        sqlda = New SqlDataAdapter( _
         strQuery, sqlcnn)

        ' Create a DataSet object 
        ' to hold the results
        ds = New DataSet()

        ' Fill the DataSet object
        sqlda.Fill(ds, "Results")

        ExecuteQuery = ds
    End Function

    ' This method updates the database with
    ' the changes in a DataSet object
    Public Function UpdateData( _
     ByVal ds As DataSet) As Integer _
     Implements INorthwind.UpdateData
        ' Update the database 
        ' and return the result
        Dim sqlcb As SqlCommandBuilder = _
         New SqlCommandBuilder(sqlda)
        UpdateData = sqlda.Update( _
         ds.Tables("Results"))
    End Function
End Class

