Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.EnterpriseServices
Imports System.Runtime.InteropServices
Imports System.Diagnostics

Public Interface INorthwind
    Function ExecuteQuery( _
     ByVal strQuery As String) As DataSet
    Function UpdateData( _
     ByVal strQuery As String, ByVal ds As DataSet) _
     As Integer
End Interface

<EventTrackingEnabled(True), _
 JustInTimeActivation(True), _
 ObjectPooling(True, 2, 4), _
 Guid("ABD66595-EFF2-430e-9821-A7F77DE70723"), _
 ClassInterface(ClassInterfaceType.None)> _
Public Class NorthwindSC
    Inherits ServicedComponent
    Implements INorthwind

    Private sqlcnn As SqlConnection
    Private sqlda As SqlDataAdapter
    Private ds As DataSet
    Private el As EventLog

    Public Sub New()
        ' Create a connection to the 
        ' Northwind SQL Server database
        sqlcnn = New SqlConnection( _
         "data source=(local);" & _
         "initial catalog=Northwind;" & _
         "integrated security=SSPI")

        ' Create an EventLog object 
        ' and assign its source
        el = New EventLog()
        el.Source = "Exercise7-1"
        ' Write an entry to the event log
        el.WriteEntry("A new " & _
         "NorthwindSC object is created " & _
         " and added to the object pool")
    End Sub

    Protected Overrides Sub Activate()
        el.WriteEntry( _
         "A NorthwindSC object is " & _
         "activated from the object pool")
    End Sub

    Protected Overrides Sub Deactivate()
        el.WriteEntry( _
         "A NorthwindSC object is " & _
         " deactivated and is " & _
         "returned to the object pool")
    End Sub

    Protected Overrides Function CanBePooled() _
     As Boolean
        CanBePooled = True
    End Function

    Public Function ExecuteQuery( _
     ByVal strquery As String) As DataSet _
     Implements INorthwind.ExecuteQuery
        ' Create a SqlDataAdapter object
        ' to talk to the database
        sqlda = New SqlDataAdapter( _
           strquery, sqlcnn)

        ' Create a DataSet object 
        ' to hold the results
        ds = New DataSet()

        ' Fill the DataSet object
        sqlda.Fill(ds, "Results")
        ' Deactivate the object 
        ' when the method returns
        ContextUtil.DeactivateOnReturn = True

        ExecuteQuery = ds
    End Function

    <AutoComplete()> _
    Public Function UpdateData( _
     ByVal strQuery As String, _
     ByVal ds As DataSet) As Integer _
     Implements INorthwind.UpdateData
        ' Update the database 
        sqlda = New SqlDataAdapter( _
         strQuery, sqlcnn)
        Dim sqlcb As SqlCommandBuilder = _
         New SqlCommandBuilder(sqlda)
        UpdateData = sqlda.Update( _
         ds.Tables("Results"))
    End Function
End Class
