Public Class Primes
    Public Function HighPrime(ByVal Max As Long) As Long
        Dim a() As Byte
        Dim intI As Integer
        Dim intJ As Integer

        ReDim a(Max)

        ' In the array, 1 indicates a prime,
        ' 0 indicates nonprime. Start by marking multiples
        ' of 2 as nonprime
        For intI = 0 To Max
            If intI Mod 2 = 0 And intI <> 2 Then
                a(intI) = 0
            Else
                a(intI) = 1
            End If
        Next intI
        ' Now execute the usual 
        ' sieve of erasthones algorithm
        For intI = 3 To System.Math.Sqrt(Max) Step 2
            If a(intI) = 1 Then
                ' This is a prime, so 
                ' eliminate its multiples
                For intJ = intI + intI To Max Step intI
                    a(intJ) = 0
                Next intJ
            End If
        Next intI
        ' Find the largest prime by working backwards
        For intI = Max To 1 Step -1
            If a(intI) = 1 Then
                HighPrime = intI
                Exit For
            End If
        Next intI

    End Function

End Class
